<?php

/**
 * @file
 * Definition of
 *   Drupal\wn_events\Plugin\views\field\WnEventsOrderUsername
 */

namespace Drupal\wn_events\Plugin\views\field;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Link;
use Drupal\Core\Url;
use Drupal\views\Annotation\ViewsField;
use Drupal\views\Plugin\views\field\FieldPluginBase;
use Drupal\views\ResultRow;
use Drupal\wn_events\WnEventsPerformance;

/**
 * Field handler class group views operation.
 *
 * @ingroup views_field_handlers
 *
 * @ViewsField("wn_events_order_username")
 */
class WnEventsOrderUsername extends FieldPluginBase {

  /**
   * @{inheritdoc}
   */
  public function query() {
    // Leave empty to avoid a query on this field.
  }

  /**
   * Define the available options
   *
   * @return array
   */
  protected function defineOptions() {
    return parent::defineOptions();
  }

  /**
   * Provide the options form.
   */
  public function buildOptionsForm(&$form, FormStateInterface $form_state) {
    parent::buildOptionsForm($form, $form_state);
  }

  /**
   * @{inheritdoc}
   */
  public function render(ResultRow $values) {
    $entity = $this->getEntity($values);
    $order_number = $entity->get('field_wn_order_number')->value;
    $comments = \Drupal::entityTypeManager()
      ->getStorage('comment')
      ->loadByProperties([
        'comment_type' => 'wn_events_comment',
        'field_wn_order_number' => $order_number,
      ]);
    $comment = reset($comments);
    $order_username = NULL;
    if(!empty($comment)){
      $order_username = $comment->get('field_wn_events_name')->value;
    }
    return $order_username;
  }

}
